package account

import (
	"net/http"
	"simple-bank/pkg/gateways/http/util/response"
)

func (h Handler) List(w http.ResponseWriter, r *http.Request) {
	accounts, err := h.usecase.List(r.Context())
	if err != nil {
		response.SendError(w, response.ErrIntervalServer, http.StatusInternalServerError)
		return
	}

	res := make([]ResponseBody, len(accounts))

	for i, acc := range accounts {
		res[i] = ResponseBody{
			ID:        acc.ID,
			Name:      acc.Name,
			CPF:       acc.CPF,
			Balance:   acc.Balance,
			CreatedAt: acc.CreatedAt,
		}
	}

	response.Send(w, res, http.StatusOK)
}
